"""
Simulating quantum circuits with JAX
"""


from qujax.version import __version__

from qujax import gates

from qujax.statetensor import apply_gate
from qujax.statetensor import get_params_to_statetensor_func
from qujax.statetensor import get_params_to_unitarytensor_func

from qujax.statetensor_observable import statetensor_to_single_expectation
from qujax.statetensor_observable import get_statetensor_to_expectation_func
from qujax.statetensor_observable import get_statetensor_to_sampled_expectation_func

from qujax.densitytensor import _kraus_single
from qujax.densitytensor import kraus
from qujax.densitytensor import get_params_to_densitytensor_func
from qujax.densitytensor import partial_trace

from qujax.densitytensor_observable import densitytensor_to_single_expectation
from qujax.densitytensor_observable import get_densitytensor_to_expectation_func
from qujax.densitytensor_observable import get_densitytensor_to_sampled_expectation_func
from qujax.densitytensor_observable import densitytensor_to_measurement_probabilities
from qujax.densitytensor_observable import densitytensor_to_measured_densitytensor

from qujax.utils import UnionCallableOptionalArray
from qujax.utils import check_unitary
from qujax.utils import check_hermitian
from qujax.utils import check_circuit
from qujax.utils import print_circuit
from qujax.utils import integers_to_bitstrings
from qujax.utils import bitstrings_to_integers
from qujax.utils import sample_integers
from qujax.utils import sample_bitstrings
from qujax.utils import statetensor_to_densitytensor

# pylint: disable=undefined-variable
del version
del statetensor
del statetensor_observable
del densitytensor
del densitytensor_observable
del utils
